/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/

#include <ncbi.h>
#include <dfa.h>

/*************************************************************************
 *	dfa_scanf(dp, report)
 *
 *	Use the specified DFA to scan standard input and report matches.
 *************************************************************************/
DFA_Error _cdecl
dfa_scanf(dp, report)
	DFAPtr	dp;
	/* Call-back function to report matches */
	int	(_cdecl *report) PROTO((size_t off, DFA_PatID patID));
{
	extern int _cdecl	fgetc PROTO((FILE *));
#ifdef WIN_DUMB
	/* Well, so I cheated a little */
	return dfa_pscanf(dp, (int (_cdecl *) PROTO((Nlm_VoidPtr)))fgetc, stdin, report);
#else
	return dfaErrUnknown;
#endif
}
