#include <ncbi.h>
#include <gishlib.h>

/*
	fct_factorial(n)

	Returns n! as a double.
*/

double
fct_factorial(n)
	long	n;
{
	static double	precomputed[64]
		= { 1., 1., 2., 6., 24., 120., 720., 5040., 40320., 362880., 3628800.,
			39916800., 479001600., 6227020800. };
	static int	nlim = 13;

	if (n < 0)
		return 0.0; /* Undefined! */

	if (n >= DIM(precomputed))
		return floor(0.5 + fct_gamma((double)(n+1)));

	while (nlim < n) {
		precomputed[nlim+1] = precomputed[nlim] * (nlim+1);
		++nlim;
	}
	return precomputed[n];
}

