#include <ncbi.h>
#include <signal.h>
#include <gishlib.h>

int
run_wild(n, func, userp, tickproc, nticks, numprocs, nprocs, sigterm)
	unsigned long	n; /* Number of discrete subtasks */
	void	(_cdecl *func)();
	Nlm_VoidPtr	userp;
	void	(_cdecl *tickproc)();
	unsigned long	nticks;
	int		numprocs;
	int		PNTR nprocs;
	void	(_cdecl *sigterm)();
{
	TaskBlkPtr	tp;

	if (n == 0)
		return 0;

	tp = TaskNew(n, userp, tickproc, nticks);
	tp->nprocs = tp->proc_max = 1;
	TaskInit(tp, 1);
	signal(SIGTERM, sigterm);
	*nprocs = 1;
	(*func)(userp, tp);
	*nprocs = 0;
	tp->nprocs = 0;
	numprocs = tp->proc_max;
	TaskDestruct(tp);
	return numprocs;
}
